# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/task.ipynb.

# %% auto 0
__all__ = ['Task']

# %% ../nbs/task.ipynb 4
# %load_ext autoreload
# %autoreload 2
from .api import MaticaAPIClient
from .aws import AwsClient

# %% ../nbs/task.ipynb 5
class Task:

    def __init__(self, 
                 dashboard_url, 
        dashboard_username,
        dashboard_api_key,
        storage_service_url,
        storage_service_username,
        storage_service_password,
        aws_access_key_id,
        aws_secret_access_key):

        self.matica_client = MaticaAPIClient(dashboard_url, dashboard_username, dashboard_api_key, storage_service_url, storage_service_username, storage_service_password)

        self.aws_client = AwsClient(aws_access_key_id, aws_secret_access_key, "us-east-1")

    @staticmethod
    def main(dashboard_url, 
        dashboard_username,
        dashboard_api_key,
        storage_service_url,
        storage_service_username,
        storage_service_password,
        aws_access_key_id,
        aws_secret_access_key, task_id, transfer_type, transfer_name, file_path):
        
        task = Task(dashboard_url, 
        dashboard_username,
        dashboard_api_key,
        storage_service_url,
        storage_service_username,
        storage_service_password,
        aws_access_key_id,
        aws_secret_access_key)

        matica_client = task.matica_client

        s3_path = "transfer_source/" + task_id

        bucket_name = "archivematica.aws.ldas.jp"

        task.aws_client.upload_to_s3_zip(file_path, s3_path, bucket_name)

        location_uuid = "8ba875f0-0e78-4c98-a608-751a362e3194"
        processing_config = "automated"

        transfer_UUID = task.matica_client.v2beta_package(transfer_type, "", location_uuid, "/" + s3_path, transfer_name, processing_config=processing_config)

        sip_UUID = matica_client.check_transfer_status(transfer_UUID)
        ingest_UUID = matica_client.ingest(sip_UUID)
        # url = matica_client.get_aip_url(ingest_UUID)

        

        url = "https://s3.amazonaws.com/" + bucket_name + matica_client.get_current_full_path(ingest_UUID)

        return url

        # print(task.matica_client.dashbord_url)
        # print(task.aws_client.s3)
